/// <reference types="jquery" />
export interface JsViewportSettings {
    container?: Window | HTMLElement | JQuery;
    sides: JsViewportSides[];
    top?: number;
    right?: number;
    bottom?: number;
    left?: number;
}
export interface JsViewportConfig {
    container: HTMLElement | Window;
    sides: JsViewportSides[];
    top: number;
    right: number;
    bottom: number;
    left: number;
}
export declare enum JsViewportSides {
    ALL = "ALL",
    TOP = "TOP",
    RIGHT = "RIGHT",
    BOTTOM = "BOTTOM",
    LEFT = "LEFT"
}
export declare type JsViewportSidesRef<T = any> = {
    [key in keyof typeof JsViewportSides]: T;
};
export declare const jsViewportDefaults: JsViewportConfig;
